Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/ST_Intersects.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/ST_Intersects.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/ST_Intersects.java	(revision 44198)
@@ -0,0 +1,43 @@
+package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;
+
+import java.text.MessageFormat;
+import java.util.List;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_ST_INTERSECTS;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
+import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.fmap.dal.SQLBuilder;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class ST_Intersects implements Formatter<Value> {
+    
+    private final SQLBuilder sqlbuilder;
+    private final Formatter<Value> formatter;
+    
+    public ST_Intersects(SQLBuilder sqlbuilder, Formatter<Value> formatter) {
+        this.sqlbuilder = sqlbuilder;
+        this.formatter = formatter;
+    }
+    @Override
+    public boolean canApply(ExpressionBuilder.Value value) {
+        if (value instanceof ExpressionBuilder.Function) {
+            return StringUtils.equalsIgnoreCase(FUNCTION_ST_INTERSECTS, ((Function) value).name());
+        }
+        return false;
+    }
+
+    @Override
+    public String format(Value function) {
+        List<Value> parameters = ((Function) function).parameters();
+        String p1 = parameters.get(0).toString(formatter);
+        String p2 = parameters.get(1).toString(formatter);
+        String r = MessageFormat.format("( (({0}) && ({1})) AND ST_Intersects(({0}),({1}) ))", p1, p2);
+        return r;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/ST_GeomFromEWKB.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/ST_GeomFromEWKB.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/ST_GeomFromEWKB.java	(revision 44198)
@@ -0,0 +1,43 @@
+package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;
+
+import java.text.MessageFormat;
+import java.util.List;
+import org.apache.commons.lang3.StringUtils;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_ST_GEOMFROMEWKB;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
+import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.fmap.dal.SQLBuilder;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+class ST_GeomFromEWKB implements Formatter<Value> {
+
+    private final Formatter<Value> formatter;
+    private final SQLBuilder builder;
+    
+    public ST_GeomFromEWKB(SQLBuilder builder, Formatter<Value> formatter) {
+        this.builder = builder;
+        this.formatter = formatter;
+    }
+    
+    @Override
+    public boolean canApply(Value value) {
+        if (value instanceof Function) {
+            return StringUtils.equalsIgnoreCase(FUNCTION_ST_GEOMFROMEWKB, ((Function) value).name());
+        }
+        return false;
+    }
+
+    @Override
+    public String format(Value function) {
+        List<Value> parameters = ((Function) function).parameters();
+        String p1 = parameters.get(0).toString(formatter);
+        String p2 = parameters.get(1).toString(formatter);
+        String r = MessageFormat.format("ST_GeomFromWKB({0}, {1})", p1, p2);
+        return r;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/H2SpatialFormatter.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/H2SpatialFormatter.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/H2SpatialFormatter.java	(revision 44198)
@@ -0,0 +1,50 @@
+package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;
+
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
+import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.fmap.dal.SQLBuilder;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class H2SpatialFormatter implements Formatter<Value> {
+
+    private final SQLBuilder builder;
+    private final Formatter<ExpressionBuilder.Value>[] formatters;
+
+    public H2SpatialFormatter(SQLBuilder builder) {
+
+        this.builder = builder;
+        this.formatters = new Formatter[]{
+            new IfNull(this.builder, this),
+            new IsNotNull(this.builder, this),
+            new IsNull(this.builder, this),
+            new ST_AsEWKB(this.builder, this),
+            new ST_GeomFromEWKB(this.builder, this),
+            new ST_Intersects(this.builder, this)
+        };
+    }
+
+    @Override
+    public boolean canApply(Value value) {
+        for (Formatter<Value> formatter : formatters) {
+            if (formatter.canApply(value)) {
+                return true;
+            }
+        }
+        return false;
+    }
+
+    @Override
+    public String format(Value value) {
+        for (Formatter<Value> formatter : formatters) {
+            if (formatter.canApply(value)) {
+                return formatter.format(value);
+            }
+        }
+        return value.toString(this);
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/ST_AsEWKB.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/ST_AsEWKB.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/expressionbuilderformatter/ST_AsEWKB.java	(revision 44198)
@@ -0,0 +1,43 @@
+package org.gvsig.fmap.dal.store.h2.expressionbuilderformatter;
+
+import java.text.MessageFormat;
+import java.util.List;
+import org.apache.commons.lang3.StringUtils;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_ST_ASEWKB;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Function;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
+import org.gvsig.expressionevaluator.Formatter;
+import org.gvsig.fmap.dal.SQLBuilder;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+class ST_AsEWKB implements Formatter<Value> {
+
+    private final Formatter<Value> formatter;
+    private final SQLBuilder builder;
+    
+    public ST_AsEWKB(SQLBuilder builder, Formatter<Value> formatter) {
+        this.builder = builder;
+        this.formatter = formatter;
+    }
+    
+    @Override
+    public boolean canApply(Value value) {
+        if (value instanceof Function) {
+            return StringUtils.equalsIgnoreCase(FUNCTION_ST_ASEWKB, ((Function) value).name());
+        }
+        return false;
+    }
+
+    @Override
+    public String format(Value function) {
+        List<Value> parameters = ((Function) function).parameters();
+        String p1 = parameters.get(0).toString(formatter);
+        String p2 = parameters.get(1).toString(formatter);
+        String r = MessageFormat.format("ST_AsWKB({0}, {1})", p1, p2);
+        return r;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialConnectionParametersHelper.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialConnectionParametersHelper.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialConnectionParametersHelper.java	(revision 44198)
@@ -30,9 +30,8 @@
 
     public void validate() throws ValidateDataParametersException {
         if( this.getDynValue(JDBCConnectionParameters.JDBC_DRIVER_CLASS_PARAMTER_NAME) == null ) {
-            this.setDynValue(
-                JDBCConnectionParameters.JDBC_DRIVER_CLASS_PARAMTER_NAME,
-                H2SpatialHelper.H2SpatialJDBCDriver
+            this.setDynValue(JDBCConnectionParameters.JDBC_DRIVER_CLASS_PARAMTER_NAME,
+                H2SpatialHelper.H2SPATIAL_JDBC_DRIVER
             );
         }
         if( getFile() == null ) {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialLibrary.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialLibrary.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialLibrary.java	(revision 44198)
@@ -53,9 +53,9 @@
                 (DataManagerProviderServices) DALLocator.getDataManager();
 
         try {
-            Class.forName(H2SpatialHelper.H2SpatialJDBCDriver);
+            Class.forName(H2SpatialHelper.H2SPATIAL_JDBC_DRIVER);
         } catch(Throwable th) {
-            H2SpatialHelper.logger.warn("Can't load H2Spatial JDBC Driver.",th);
+            H2SpatialHelper.LOGGER.warn("Can't load H2Spatial JDBC Driver.",th);
         }
         
         DBHelper.registerParametersDefinition(
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialSQLBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialSQLBuilder.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/H2SpatialSQLBuilder.java	(revision 44198)
@@ -1,21 +1,28 @@
 package org.gvsig.fmap.dal.store.h2;
 
 import java.sql.PreparedStatement;
+import java.sql.SQLException;
 import java.text.MessageFormat;
 import java.util.ArrayList;
 import java.util.Date;
 import java.util.List;
 import org.apache.commons.lang3.tuple.Pair;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Parameter;
+import org.gvsig.expressionevaluator.Formatter;
 import org.gvsig.fmap.dal.DataTypes;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.fmap.dal.feature.spi.FeatureProvider;
+import org.gvsig.fmap.dal.store.h2.expressionbuilderformatter.H2SpatialFormatter;
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
 import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.exception.CreateGeometryException;
 import org.gvsig.tools.dispose.Disposable;
 
 public class H2SpatialSQLBuilder extends JDBCSQLBuilderBase {
 
+    protected Formatter formatter = null;
+    
     public H2SpatialSQLBuilder(H2SpatialHelper helper) {
         super(helper);
         
@@ -30,54 +37,53 @@
         // http://www.h2database.com/html/datatypes.html
         //
         //
+
         
-        config.set(SQLConfig.default_schema, "");
-        config.set(SQLConfig.support_schemas, false);
-        config.set(SQLConfig.allowAutomaticValues, true);
-        config.set(SQLConfig.geometry_type_support, this.helper.getGeometrySupportType());
-        config.set(SQLConfig.has_spatial_functions, this.helper.hasSpatialFunctions());
+        this.defaultSchema = "";
+        this.supportSchemas = false;
+        this.allowAutomaticValues = true;
+        this.geometrySupportType = this.helper.getGeometrySupportType();
+        this.hasSpatialFunctions = this.helper.hasSpatialFunctions();
 
-        config.remove_functionality(SQLConfig.DELETE_GEOMETRY_COLUMN_FROM_TABLE_schema_table);
-        config.remove_functionality(SQLConfig.DELETE_GEOMETRY_COLUMN_FROM_TABLE_table);
+        this.STMT_DELETE_GEOMETRY_COLUMN_FROM_TABLE_schema_table = null;
+        this.STMT_DELETE_GEOMETRY_COLUMN_FROM_TABLE_table = null;
          
-//        config.set(SQLConfig.UPDATE_TABLE_STATISTICS_table,"ANALYZE TABLE {0} SAMPLE_SIZE 0");
-        config.set(SQLConfig.UPDATE_TABLE_STATISTICS_table,"ANALYZE SAMPLE_SIZE 0");
+        this.STMT_UPDATE_TABLE_STATISTICS_table = "ANALYZE SAMPLE_SIZE 0";
 
-        config.set(SQLConfig.ST_GeomFromEWKB, "GeomFromWKB({0}, {1})");
-        config.set(SQLConfig.ST_AsEWKB, "AsWKB(({0}))");        
-        config.set(SQLConfig.ST_Intersects, "( (({0}) && ({1})) AND ST_Intersects(({0}),({1}) ))");  
-        config.set(SQLConfig.ST_AsBinary, "NVL2({0}, ST_AsBinary({0}), null)");
-        
-        config.set(SQLConfig.lcase, "LOWER({0})");
-        config.set(SQLConfig.ucase, "UPPER({0})");
-        config.set(SQLConfig.operator_ILIKE, "({0}) ILIKE ({1})");
-        config.set(SQLConfig.isNull, "( ({0}) IS NULL )");
-        config.set(SQLConfig.notIsNull, "( ({0}) IS NOT NULL )");
+//        config.set(SQLConfig.ST_AsBinary, "NVL2({0}, ST_AsBinary({0}), null)");
 
-        config.set(SQLConfig.type_boolean, "BOOLEAN");
-        config.set(SQLConfig.type_byte, "TINYINT");
-        config.set(SQLConfig.type_bytearray, "TINYINT");
-        config.set(SQLConfig.type_geometry, "GEOMETRY");
-        config.set(SQLConfig.type_char, "CHAR");
-        config.set(SQLConfig.type_date, "DATE");
-        config.set(SQLConfig.type_double, "DOUBLE"); 
-        config.set(SQLConfig.type_numeric_p, "DECIMAL({0})");
-        config.set(SQLConfig.type_numeric_ps, "DECIMAL({0},{1})");
-        config.set(SQLConfig.type_bigdecimal, "DOUBLE");
-        config.set(SQLConfig.type_float, "REAL");
-        config.set(SQLConfig.type_int, "INTEGER");
-        config.set(SQLConfig.type_long, "BIGINT");
-        config.set(SQLConfig.type_string, "VARCHAR");
-        config.set(SQLConfig.type_string_p, "VARCHAR({0})");
-        config.set(SQLConfig.type_time, "TIME");
-        config.set(SQLConfig.type_timestamp, "TIMESTAMP");
-        config.set(SQLConfig.type_version, "VARCHAR");
-        config.set(SQLConfig.type_URI, "VARCHAR");
-        config.set(SQLConfig.type_URL, "VARCHAR");
-        config.set(SQLConfig.type_FILE, "VARCHAR");
-        config.set(SQLConfig.type_FOLDER, "VARCHAR");        
+        this.type_boolean = "BOOLEAN";
+        this.type_byte = "TINYINT";
+        this.type_bytearray = "TINYINT";
+        this.type_geometry = "GEOMETRY";
+        this.type_char = "CHAR";
+        this.type_date = "DATE";
+        this.type_double = "DOUBLE"; 
+        this.type_numeric_p = "DECIMAL({0})";
+        this.type_numeric_ps = "DECIMAL({0},{1})";
+        this.type_bigdecimal = "DOUBLE";
+        this.type_float = "REAL";
+        this.type_int = "INTEGER";
+        this.type_long = "BIGINT";
+        this.type_string = "VARCHAR";
+        this.type_string_p = "VARCHAR({0})";
+        this.type_time = "TIME";
+        this.type_timestamp = "TIMESTAMP";
+        this.type_version = "VARCHAR";
+        this.type_URI = "VARCHAR";
+        this.type_URL = "VARCHAR";
+        this.type_FILE = "VARCHAR";
+        this.type_FOLDER = "VARCHAR";        
     }
 
+    @Override
+    protected Formatter formatter() {
+        if( this.formatter==null ) {
+            this.formatter = new H2SpatialFormatter(this);
+        }
+        return this.formatter;
+    }
+
     public class H2SpatialTableNameBuilderBase extends TableNameBuilderBase {
 
         @Override
@@ -95,7 +101,7 @@
     public class H2SpatialCreateIndexBuilder extends CreateIndexBuilderBase {
     
         @Override
-        public List<String> toStrings() {
+        public List<String> toStrings(Formatter formatter) {
             StringBuilder builder = new StringBuilder();
             builder.append("CREATE ");
             if( this.isUnique ) {
@@ -108,9 +114,9 @@
             if( this.ifNotExist ) {
                 builder.append("IF NOT EXISTS ");
             }
-            builder.append(identifier(this.indexName));
+            builder.append(as_identifier(this.indexName));
             builder.append(" ON ");
-            builder.append(this.table.toString());
+            builder.append(this.table.toString(formatter));
             builder.append(" ( ");
             boolean is_first_column = true;
             for( String column : this.columns) {
@@ -119,7 +125,7 @@
                 } else {
                     builder.append(", ");
                 }
-                builder.append(identifier(column));
+                builder.append(as_identifier(column));
             }
             builder.append(" )");
             
@@ -132,7 +138,7 @@
         
     protected class H2SpatialAlterTableBuilderBase extends AlterTableBuilderBase {
         @Override
-        public List<String> toStrings() {
+        public List<String> toStrings(Formatter formatter) {
             List<String> sqls = new ArrayList<>();
             if( this.isEmpty() ) {
                 return sqls;
@@ -140,17 +146,17 @@
             for (String column : drops) {
                 StringBuilder builder = new StringBuilder();
                 builder.append("ALTER TABLE ");
-                builder.append(this.table.toString());
+                builder.append(this.table.toString(formatter));
                 builder.append(" DROP COLUMN IF EXISTS ");
-                builder.append(identifier(column)); 
+                builder.append(as_identifier(column)); 
                 sqls.add(builder.toString());
             }
             for (ColumnDescriptor column : adds) {
                 StringBuilder builder = new StringBuilder();
                 builder.append("ALTER TABLE ");
-                builder.append(this.table.toString());
+                builder.append(this.table.toString(formatter));
                 builder.append(" ADD COLUMN ");
-                builder.append(identifier(column.getName())); 
+                builder.append(as_identifier(column.getName())); 
                 builder.append(" ");
                 if( column.getType() == DataTypes.INT && column.isAutomatic() ) {
                     builder.append(" SERIAL");
@@ -200,9 +206,9 @@
             for (ColumnDescriptor column : alters) {
                 StringBuilder builder = new StringBuilder();
                 builder.append("ALTER TABLE ");
-                builder.append(this.table.toString());
+                builder.append(this.table.toString(formatter));
                 builder.append(" ALTER COLUMN ");
-                builder.append(identifier(column.getName())); 
+                builder.append(as_identifier(column.getName())); 
                 builder.append(" ");
                 builder.append(
                     sqltype(
@@ -242,11 +248,11 @@
             for (Pair<String,String> pair : renames) {
                 StringBuilder builder = new StringBuilder();
                 builder.append("ALTER TABLE ");
-                builder.append(this.table.toString());
+                builder.append(this.table.toString(formatter));
                 builder.append(" RENAME COLUMN ");
-                builder.append(identifier(pair.getLeft())); 
+                builder.append(as_identifier(pair.getLeft())); 
                 builder.append(" TO ");
-                builder.append(identifier(pair.getRight())); 
+                builder.append(as_identifier(pair.getRight())); 
                 sqls.add(builder.toString());
             }
             return sqls;
@@ -257,13 +263,13 @@
     protected class H2SpatialCreateTableBuilder extends CreateTableBuilderBase {
 
         @Override
-        public List<String> toStrings() {
+        public List<String> toStrings(Formatter formatter) {
 
             List<String> sqls = new ArrayList<>();
             StringBuilder builder = new StringBuilder();
 
             builder.append("CREATE TABLE ");
-            builder.append(this.table.toString());
+            builder.append(this.table.toString(formatter));
             builder.append(" (");
             boolean first = true;
             for (ColumnDescriptor column : columns) {
@@ -273,7 +279,7 @@
                 } else {
                     builder.append(", ");
                 }
-                builder.append(identifier(column.getName()));
+                builder.append(as_identifier(column.getName()));
                 builder.append(" ");
                 builder.append(
                     sqltype(
@@ -364,7 +370,7 @@
         }        
         
         @Override
-        public String toString() {
+        public String toString(Formatter formatter) {
             StringBuilder builder = new StringBuilder();
             if( !isValid(builder) ) {
                 throw new IllegalStateException(builder.toString());
@@ -380,16 +386,16 @@
                 } else {
                     builder.append(", ");
                 }
-                builder.append(column.toString());
+                builder.append(column.toString(formatter));
             }
 
             if ( this.has_from() ) {
                 builder.append(" FROM ");
-                builder.append(this.from.toString());
+                builder.append(this.from.toString(formatter));
             }
             if ( this.has_where() ) {
                 builder.append(" WHERE ");
-                builder.append(this.where.toString());
+                builder.append(this.where.toString(formatter));
             }
             
             if( this.has_order_by() ) {
@@ -401,7 +407,7 @@
                     } else {
                         builder.append(", ");
                     }
-                    builder.append(item.toString());                    
+                    builder.append(item.toString(formatter));                    
                 }   
             }
             
@@ -425,20 +431,6 @@
     }
 
     @Override
-    public String bytearray(byte[] data) {
-        // H2Spatial usa un formato diferencte para especificar un array de 
-        // bytes. En lugar de 0x... usa x'...' .
-        StringBuilder builder = new StringBuilder();
-        builder.append("x'");
-        for (byte abyte : data) {
-            int v = abyte & 0xff;
-            builder.append(String.format("%02x", v));
-        }
-        builder.append("'");
-        return builder.toString();
-    }
-
-    @Override
     public Object sqlgeometrydimension(int type, int subtype) {
         //'XY' or 2: 2D points, identified by X and Y coordinates
         //'XYM': 2D points, identified by X and Y coordinates. Each point stores an M-value (measure) as well
@@ -502,6 +494,7 @@
         return dimensions;
     }
     
+    @Override
     public H2SpatialHelper getHelper() {
         return (H2SpatialHelper) this.helper;
     }
@@ -511,11 +504,11 @@
         try {
             FeatureType featureType = feature.getType();
             List<Object> values = new ArrayList<>();
-            for (Parameter parameter : this.getParameters()) {
+            for (Parameter parameter : this.parameters()) {
                 if (parameter.is_constant()) {
-                    values.add(parameter.getValue());
+                    values.add(parameter.value());
                 } else {
-                    String name = parameter.getName();
+                    String name = parameter.name();
                     FeatureAttributeDescriptor descriptor = featureType.getAttributeDescriptor(name);
                     switch( descriptor.getType() ) {
                     case DataTypes.DATE:
@@ -540,7 +533,7 @@
                 }
             }
             return this.setStatementParameters(st, values, this.geometry_support_type());
-        } catch (Exception ex) {
+        } catch (SQLException | CreateGeometryException ex) {
             String f = "unknow";
             try {
                 f = feature.toString();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialAppendOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialAppendOperation.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.h2/src/main/java/org/gvsig/fmap/dal/store/h2/operations/H2SpatialAppendOperation.java	(revision 44198)
@@ -3,6 +3,7 @@
 
 import java.sql.PreparedStatement;
 import java.sql.SQLException;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
 import org.gvsig.fmap.dal.DataTypes;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
@@ -20,7 +21,7 @@
 
 @SuppressWarnings("UseSpecificCatch")
 public class H2SpatialAppendOperation extends AppendOperation {
-    
+
     public H2SpatialAppendOperation(
             JDBCHelper helper, 
             TableReference table, 
@@ -39,6 +40,7 @@
             this.connection = this.helper.getConnectionWritable();
             
             this.sqlbuilder = this.helper.createSQLBuilder();
+            this.expbuilder = this.sqlbuilder.expression();
 
             this.sqlbuilder.insert().table()
                 .database(this.table.getDatabase())
@@ -50,13 +52,13 @@
                 }
                 if (attr.getType() == DataTypes.GEOMETRY) {
                     this.sqlbuilder.insert().column().name(attr.getName()).with_value( 
-                        sqlbuilder.parameter(attr.getName()).as_geometry_variable().srs( 
-                                sqlbuilder.parameter().value(attr.getSRS()) 
+                        this.expbuilder.parameter(attr.getName()).as_geometry_variable().srs( 
+                                this.expbuilder.parameter().value(attr.getSRS()) 
                         ) 
                     );
                 } else {
                     this.sqlbuilder.insert().column().name(attr.getName()).with_value(
-                        sqlbuilder.parameter(attr.getName()).as_variable()
+                        this.expbuilder.parameter(attr.getName()).as_variable()
                     );
                 }
             }
